﻿Imports KMotion_dotNet
Imports System.Threading


Public Class Form1
    Public WithEvents ThisController As New KM_Controller
    Public WithEvents ThisCoordMotion As New KM_CoordMotion(ThisController)
    Public WithEvents ThisInterpreter As New KM_Interpreter(ThisCoordMotion)


#Region "Form1_Load"
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Dim G_AppPath As String = System.IO.Path.GetDirectoryName(Application.ExecutablePath)

        Console.WriteLine("  FIRMWARE v" & ThisController.GetFirmwareVersion)
        Dim AllBoards As Integer()
        Dim NumberOfBoards As Int32
        AllBoards = ThisController.GetBoards(NumberOfBoards)
        Console.WriteLine("  Boards total: " & NumberOfBoards)
        Console.WriteLine("  Board ID: " & ThisController.BoardID)
        Console.WriteLine("  Board Type: " & ThisController.BoardType)
        Console.WriteLine("  Board is connected: " & ThisController.CheckConnected)
        Console.WriteLine("  Board is ready: " & ThisController.CheckIsReady)
        Console.WriteLine("--------------------------------------------------------------")



        Dim ThisCCode_CompletePathFile As String
        Dim Result As String
        Dim ThreadNumber As Byte



        ThisCCode_CompletePathFile = G_AppPath & "\C_Code\SomethingSimple.c"
        ThreadNumber = 4

        For i As Int16 = 1 To 500
            If System.IO.File.Exists(G_AppPath & "\tcc67.exe") = True Then 'Test for existence of the tcc67.exe file
                'System.Threading.Thread.Sleep(200) 'Attempted a pause here in case the compiler was not returning fast enough. Made no difference.
                Try
                    Result = ThisController.CompileAndLoadCoff(ThreadNumber, ThisCCode_CompletePathFile, False)
                    Console.WriteLine("Successful compilation/download #" & i & " returned:<" & Result & ">")
                Catch EX As Exception
                    Console.WriteLine("ERROR TRAPPED ATTEMPTING EXECUTION #" & i)
                End Try
            Else 'tcc67.exe is missing, so don't bother continuing.
                Console.WriteLine("ERROR: TCC67.exe is missing on attempt #" & i & ". Stop attempting compiles.")
                Exit For
            End If
        Next i


    End Sub
#End Region





#Region "ThisController_MessageReceived"
    Private Function ThisController_MessageReceived(message As String) As Integer Handles ThisController.MessageReceived
        Console.WriteLine("Controller Message received: " & message)
        Return 0
    End Function
#End Region


End Class
